package blusunrize.immersiveengineering.common.blocks.stone;

import blusunrize.immersiveengineering.api.IEProperties;
import blusunrize.immersiveengineering.api.IEProperties.PropertyBoolInverted;
import blusunrize.immersiveengineering.api.Lib;
import blusunrize.immersiveengineering.api.crafting.BlastFurnaceRecipe;
import blusunrize.immersiveengineering.common.IEContent;
import blusunrize.immersiveengineering.common.blocks.IEBlockInterfaces.IActiveState;
import blusunrize.immersiveengineering.common.blocks.IEBlockInterfaces.IGuiTile;
import blusunrize.immersiveengineering.common.blocks.IEBlockInterfaces.IProcessTile;
import blusunrize.immersiveengineering.common.blocks.IEBlockInterfaces.IUsesBooleanProperty;
import blusunrize.immersiveengineering.common.blocks.TileEntityMultiblockPart;
import blusunrize.immersiveengineering.common.util.Utils;
import blusunrize.immersiveengineering.common.util.inventory.IIEInventory;
import net.minecraft.block.Block;
import net.minecraft.entity.item.EntityItem;
import net.minecraft.init.Blocks;
import net.minecraft.item.ItemStack;
import net.minecraft.nbt.NBTTagCompound;
import net.minecraft.tileentity.TileEntity;
import net.minecraft.util.EnumFacing;
import net.minecraft.util.NonNullList;
import net.minecraft.util.math.BlockPos;
import net.minecraftforge.common.capabilities.Capability;
import net.minecraftforge.fluids.FluidStack;
import net.minecraftforge.fluids.FluidTank;
import net.minecraftforge.fluids.IFluidTank;
import net.minecraftforge.items.CapabilityItemHandler;
import net.minecraftforge.oredict.OreDictionary;

public class TileEntityBlastFurnace extends TileEntityMultiblockPart<TileEntityBlastFurnace> implements IIEInventory, IActiveState, IGuiTile, IProcessTile
{
	NonNullList<ItemStack> inventory = NonNullList.func_191197_a(4, ItemStack.field_190927_a);
	public int process = 0;
	public int processMax = 0;
	public boolean active = false;
	public int burnTime = 0;
	public int lastBurnTime = 0;

	@Override
	public PropertyBoolInverted getBoolProperty(Class<? extends IUsesBooleanProperty> inf)
	{
		return inf==IActiveState.class?IEProperties.BOOLEANS[0]:null;
	}
	@Override
	public boolean getIsActive()
	{
		return this.active;
	}
	@Override
	public boolean canOpenGui()
	{
		return formed;
	}
	@Override
	public int getGuiID()
	{
		return Lib.GUIID_BlastFurnace;
	}
	@Override
	public TileEntity getGuiMaster()
	{
		return master();
	}

	@Override
	public float[] getBlockBounds()
	{
		return null;
	}

	@Override
	public ItemStack getOriginalBlock()
	{
		return new ItemStack(IEContent.blockStoneDecoration,1,1);
	}

	@Override
	public boolean isDummy()
	{
		return offset[0]!=0||offset[1]!=0||offset[2]!=0;
	}

	@Override
	public void func_73660_a()
	{
		if(!field_145850_b.field_72995_K&&formed&&!isDummy())
		{
			boolean a = active;

			if(burnTime>0)
			{
				if(process>0)
				{
					int processSpeed = getProcessSpeed();
					if(inventory.get(0).func_190926_b())
					{
						process=0;
						processMax=0;
					}
					else
					{
						BlastFurnaceRecipe recipe = getRecipe();
						if (recipe!=null&&recipe.time!=processMax)
						{
							processMax = 0;
							process = 0;
							active = false;
						}
						else
						{
							process -= processSpeed;
							if (!active)
								active = true;
						}
					}
					burnTime-=processSpeed;
					markContainingBlockForUpdate(null);
				}

				if(process<=0)
				{
					if(active)
					{
						BlastFurnaceRecipe recipe = getRecipe();
						if(recipe!=null)
						{
							Utils.modifyInvStackSize(inventory, 0, -(recipe.input instanceof ItemStack ? ((ItemStack) recipe.input).func_190916_E() : 1));
							if(!inventory.get(2).func_190926_b())
								inventory.get(2).func_190917_f(recipe.output.func_77946_l().func_190916_E());
							else
								inventory.set(2, recipe.output.func_77946_l());
							if (!recipe.slag.func_190926_b())
							{
								if(!inventory.get(3).func_190926_b())
									inventory.get(3).func_190917_f(recipe.slag.func_77946_l().func_190916_E());
								else
									inventory.set(3, recipe.slag.func_77946_l());
							}
						}
						processMax=0;
						active=false;
						burnTime -= process;
					}
					BlastFurnaceRecipe recipe = getRecipe();
					if(recipe!=null)
					{
						this.process=recipe.time;
						this.processMax=process;
						this.active=true;
					}
				}
			}
			else
			{
				if(active)
					active=false;
			}

			if(burnTime<=10 && getRecipe()!=null)
			{
				if(BlastFurnaceRecipe.isValidBlastFuel(inventory.get(1)))
				{
					burnTime += BlastFurnaceRecipe.getBlastFuelTime(inventory.get(1));
					lastBurnTime = BlastFurnaceRecipe.getBlastFuelTime(inventory.get(1));
					Utils.modifyInvStackSize(inventory, 1, -1);
					markContainingBlockForUpdate(null);
				}
			}

			if(a!=active)
			{

				this.func_70296_d();
				TileEntity tileEntity;
				for(int yy=-1;yy<=1;yy++)
					for(int xx=-1;xx<=1;xx++)
						for(int zz=-1;zz<=1;zz++)
						{
							tileEntity = field_145850_b.func_175625_s(func_174877_v().func_177982_a(xx, yy, zz));
							if(tileEntity!=null)
								tileEntity.func_70296_d();
							markBlockForUpdate(func_174877_v().func_177982_a(xx, yy, zz), null);
							field_145850_b.func_175641_c(func_174877_v().func_177982_a(xx, yy, zz), IEContent.blockStoneDevice, 1,active?1:0);
						}
			}
		}
	}
	public BlastFurnaceRecipe getRecipe()
	{
		BlastFurnaceRecipe recipe = BlastFurnaceRecipe.findRecipe(inventory.get(0));
		if(recipe==null)
			return null;
		if((inventory.get(0).func_190916_E() >= ((recipe.input instanceof ItemStack) ? ((ItemStack) recipe.input).func_190916_E() : 1)
				&& inventory.get(2).func_190926_b() || (OreDictionary.itemMatches(inventory.get(2),recipe.output,true) && inventory.get(2).func_190916_E() + recipe.output.func_190916_E() <=getSlotLimit(2)) )
				&& (inventory.get(3).func_190926_b() || (OreDictionary.itemMatches(inventory.get(3),recipe.slag,true) && inventory.get(3).func_190916_E() + recipe.slag.func_190916_E() <=getSlotLimit(3)) ))
			return recipe;
		return null;
	}

	protected int getProcessSpeed()
	{
		return 1;
	}

	@Override
	public int[] getCurrentProcessesStep()
	{
		TileEntityBlastFurnace master = master();
		if(master!=this && master!=null)
			return master.getCurrentProcessesStep();
		return new int[]{processMax-process};
	}
	@Override
	public int[] getCurrentProcessesMax()
	{
		TileEntityBlastFurnace master = master();
		if(master!=this && master!=null)
			return master.getCurrentProcessesMax();
		return new int[]{processMax};
	}

	@Override
	public boolean func_145842_c(int id, int arg)
	{
		if(id==0)
			this.formed = arg==1;
		else if(id==1)
			this.active = arg==1;
		func_70296_d();
		markContainingBlockForUpdate(null);
		return true;
	}

	@Override
	public void readCustomNBT(NBTTagCompound nbt, boolean descPacket)
	{
		super.readCustomNBT(nbt, descPacket);
		process = nbt.func_74762_e("process");
		processMax = nbt.func_74762_e("processMax");
		active = nbt.func_74767_n("active");
		burnTime = nbt.func_74762_e("burnTime");
		lastBurnTime = nbt.func_74762_e("lastBurnTime");
		if(!descPacket)
		{
			inventory = Utils.readInventory(nbt.func_150295_c("inventory", 10), 4);
		}
	}

	@Override
	public void writeCustomNBT(NBTTagCompound nbt, boolean descPacket)
	{
		super.writeCustomNBT(nbt, descPacket);
		nbt.func_74768_a("process", process);
		nbt.func_74768_a("processMax", processMax);
		nbt.func_74757_a("active", active);
		nbt.func_74768_a("burnTime", burnTime);
		nbt.func_74768_a("lastBurnTime", lastBurnTime);
		if(!descPacket)
		{
			nbt.func_74782_a("inventory", Utils.writeInventory(inventory));
		}
	}

	@Override
	public void disassemble()
	{
		if(formed && !field_145850_b.field_72995_K)
		{
			BlockPos startPos = this.func_174877_v().func_177982_a(-offset[0],-offset[1],-offset[2]);
			if(!(offset[0]==0&&offset[1]==0&&offset[2]==0) && !(field_145850_b.func_175625_s(startPos) instanceof TileEntityBlastFurnace))
				return;

			for(int yy=-1;yy<=1;yy++)
				for(int xx=-1;xx<=1;xx++)
					for(int zz=-1;zz<=1;zz++)
					{
						ItemStack s = ItemStack.field_190927_a;
						TileEntity te = field_145850_b.func_175625_s(startPos.func_177982_a(xx, yy, zz));
						if(te instanceof TileEntityBlastFurnace)
						{
							s = ((TileEntityBlastFurnace)te).getOriginalBlock();
							((TileEntityBlastFurnace)te).formed=false;
						}
						if(startPos.func_177982_a(xx, yy, zz).equals(func_174877_v()))
							s = this.getOriginalBlock();
						if(!s.func_190926_b() && Block.func_149634_a(s.func_77973_b())!= Blocks.field_150350_a)
						{
							if(startPos.func_177982_a(xx, yy, zz).equals(func_174877_v()))
								field_145850_b.func_72838_d(new EntityItem(field_145850_b, func_174877_v().func_177958_n()+.5,func_174877_v().func_177956_o()+.5,func_174877_v().func_177952_p()+.5, s));
							else
							{
								if(Block.func_149634_a(s.func_77973_b())==IEContent.blockStoneDevice)
									field_145850_b.func_175698_g(startPos.func_177982_a(xx, yy, zz));
								field_145850_b.func_175656_a(startPos.func_177982_a(xx, yy, zz), Block.func_149634_a(s.func_77973_b()).func_176203_a(s.func_77952_i()));
							}
						}
					}
		}
	}

	@Override
	public NonNullList<ItemStack> getInventory()
	{
		return this.inventory;
	}
	@Override
	public boolean isStackValid(int slot, ItemStack stack)
	{
		return slot==0?BlastFurnaceRecipe.findRecipe(stack)!=null: slot == 1 && BlastFurnaceRecipe.isValidBlastFuel(stack);
	}
	@Override
	public int getSlotLimit(int slot)
	{
		return 64;
	}
	@Override
	public void doGraphicalUpdates(int slot)
	{
	}
	@Override
	protected IFluidTank[] getAccessibleFluidTanks(EnumFacing side)
	{
		return new FluidTank[0];
	}
	@Override
	protected boolean canFillTankFrom(int iTank, EnumFacing side, FluidStack resources)
	{
		return false;
	}
	@Override
	protected boolean canDrainTankFrom(int iTank, EnumFacing side)
	{
		return false;
	}

	@Override
	public <T> T getCapability(Capability<T> capability, EnumFacing facing)
	{
		if(capability== CapabilityItemHandler.ITEM_HANDLER_CAPABILITY)
			return null;
		return super.getCapability(capability, facing);
	}
}
